import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import org.apache.poi.hslf.model.OLEShape;
import org.apache.poi.hslf.model.Shape;
import org.apache.poi.hslf.model.Slide;
import org.apache.poi.hslf.usermodel.ObjectData;
import org.apache.poi.hslf.usermodel.SlideShow;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;


public class ChangeExcel {

	/**
	 * Method just takes slides from main and try to find embedded excel object. It is opened and written back to the slide.
	 * @param slides Slides from the SlideShow
	 * @throws IOException
	 */
    public static void fillSlides(Slide [] slides) throws IOException
    {
    	for (int k=0;k<slides.length;k++)
    	{
    		Shape[] sh = null;
   			sh = slides[k].getShapes();
	    	for (int i=0;i<sh.length;i++)
	    	{
	    		if (sh[i] instanceof OLEShape) {
	    			OLEShape ole = (OLEShape) sh[i];
					ObjectData od=ole.getObjectData();
					HSSFWorkbook wb=new HSSFWorkbook(od.getData());
					ByteArrayOutputStream out = new ByteArrayOutputStream(); 
					wb.write(out); 
					od.setData(out.toByteArray());
				}
	    	}
    	}
    }
    
	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {
		String path = new java.io.File(".").getCanonicalPath();
    	FileInputStream in = new FileInputStream(path+"\\template\\template.ppt");
    	SlideShow templatePPT=new SlideShow(in);
    	in.close();
        Slide[] templateSlides=templatePPT.getSlides();
        fillSlides(templateSlides);
        FileOutputStream out=new FileOutputStream(path+"\\output\\output.ppt");
        templatePPT.write(out);
        out.close();
	}

}
